import bcrypt from "bcryptjs";

export default class User{

    private id: number | undefined;
    private name: string;
    private email: string;
    private password: string;

    public getId(){
        return this.id;
    }

    public setId(id: number){
        this.id = id;
    }

    public getName(){
        return this.name;
    }

    public setName(name: string){
        this.name = name;
    }

    public getEmail(){
        return this.email;
    }

    public setEmail(email: string){
        this.email = email;
    }

    public getPassword(){
        return this.password;
    }

    public setPassword(password: string){
        this.password = password;
    }


    constructor(id: number | undefined, name: string, email: string, password: string){
        this.id = id;
        this.name = name;
        this.email = email;
        this.password = password;
    }

    // hash
    public hashPassword(password: string){
        this.password = bcrypt.hashSync(password, bcrypt.genSaltSync(8));
    }

    // check password
    public checkPassword(password: string){
        return bcrypt.compareSync(password, this.password);
    }
}