import jwt from "jsonwebtoken";
import dotenv from "dotenv";
dotenv.config();

const { TOKEN_KEY, REFRESH_KEY } = process.env;

export default class AuthService {

    validateToken(toValidate: string) {
        return jwt.verify(toValidate, TOKEN_KEY!);
    }

    generateToken(userId: string | number, userEmail: string) {
        return jwt.sign(
            { user_id: userId, user_email: userEmail },
            TOKEN_KEY!,
            {expiresIn: "5m"}
        );
    }

    generateRefreshToken(userEmail: string){
        return jwt.sign(
            {user_email: userEmail}, 
            REFRESH_KEY!, 
            { expiresIn: '1d' });
    }
}