import { Connection } from "mysql2/promise";
import DatabaseConfig from "../config/database";
import User from "../model/user";
import { RowDataPacket } from 'mysql2/promise';

export default class DbService extends DatabaseConfig {

    private table: string;

    constructor(table: string) {
        super();
        this.table = table;
    }

    async get(value: string | number): Promise<any> {
        return this.dbIsReady().then(async () => {

            const query = `SELECT * FROM ${this.table} WHERE id = ?`;

            return DatabaseConfig.mysqlCon.execute(query, [value]);
        });
    }

    async getAll(){
        return this.dbIsReady().then(async () => {

            const query = `SELECT * FROM ${this.table}`;

            return DatabaseConfig.mysqlCon.execute(query);
        });
    }

    async save(values: any): Promise<any> {
        return this.dbIsReady().then(() => {

            const query = `INSERT INTO ${this.table} SET ${DatabaseConfig.mysqlCon.escape(values)}`;

            return DatabaseConfig.mysqlCon.execute(query);
        });
    }

    async delete(val: string | number): Promise<void> {
        return this.dbIsReady().then(() => {

            const query = `DELETE FROM ${this.table} WHERE id = ?`;

            DatabaseConfig.mysqlCon.execute(query, [val]);

        });
    }

    async customQuery(query: string, values: any): Promise<any> {
        return this.dbIsReady().then(() => {
            return DatabaseConfig.mysqlCon.execute(query, values);
        });
    }
}